package com.casic.dcms.ui.fragment.check;

import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.casic.dcms.adapter.CaseCheckResultAdapter;
import com.casic.dcms.base.AndroidxBaseFragment;
import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.bean.CaseCheckBean;
import com.casic.dcms.databinding.FragmentCheckCaseBinding;
import com.casic.dcms.mvp.presenter.impl.CaseCheckedPresenterImpl;
import com.casic.dcms.mvp.view.ICaseCheckView;
import com.casic.dcms.ui.CaseCheckedDetailActivity;
import com.casic.dcms.utils.Constant;
import com.casic.dcms.utils.ToastHelper;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnLoadMoreListener;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;

public class CaseCheckedFragment extends AndroidxBaseFragment<FragmentCheckCaseBinding> implements ICaseCheckView {

    private static final String TAG = "CaseCheckedFragment";
    private Context context;
    private CaseCheckedPresenterImpl caseCheckedPresenter;
    private int pageIndex = 1;
    private CaseCheckResultAdapter adapter;
    private List<CaseCheckBean.DataBean.RowsBean> dataBeans = new ArrayList<>();
    private boolean isRefresh, isLoadMore = false;
    private static WeakReferenceHandler weakReferenceHandler;

    @Override
    protected void setupTopBarLayout() {
        context = getContext();
    }

    @Override
    protected void initData() {
        caseCheckedPresenter = new CaseCheckedPresenterImpl(this);
        caseCheckedPresenter.onReadyRetrofitRequest(Constant.PAGE_LIMIT, pageIndex);

        weakReferenceHandler = new WeakReferenceHandler(this);
    }

    @Override
    protected void initEvent() {
        viewBinding.refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull final RefreshLayout refreshLayout) {
                isRefresh = true;
                //刷新之后页码重置
                pageIndex = 1;
                caseCheckedPresenter.onReadyRetrofitRequest(Constant.PAGE_LIMIT, pageIndex);
            }
        });
        viewBinding.refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull final RefreshLayout refreshLayout) {
                isLoadMore = true;
                pageIndex++;
                caseCheckedPresenter.onReadyRetrofitRequest(Constant.PAGE_LIMIT, pageIndex);
            }
        });
    }

    /**
     * 供{@link com.casic.dcms.ui.CaseCheckDetailActivity#obtainCaseHandleResult(ActionResultBean)}调用
     */
    public static void sendEmptyMessage(int what) {
        if (weakReferenceHandler == null) {
            return;
        }
        weakReferenceHandler.sendEmptyMessage(what);
    }

    private static class WeakReferenceHandler extends Handler {
        private final WeakReference<CaseCheckedFragment> reference;

        private WeakReferenceHandler(CaseCheckedFragment fragment) {
            reference = new WeakReference<>(fragment);
        }

        @Override
        public void handleMessage(Message msg) {
            CaseCheckedFragment checkedFragment = reference.get();
            if (msg.what == Constant.CASE_CHECK_OK) {
                Log.d(TAG, "核查成功，更新列表");
                checkedFragment.isRefresh = true;
                //刷新之后页码重置
                checkedFragment.pageIndex = 1;
                checkedFragment.caseCheckedPresenter.onReadyRetrofitRequest(Constant.PAGE_LIMIT, checkedFragment.pageIndex);
            } else if (msg.what == 202104252) {
                if (checkedFragment.isRefresh || checkedFragment.isLoadMore) {
                    checkedFragment.adapter.notifyDataSetChanged();
                } else {
                    //首次加载数据
                    if (checkedFragment.dataBeans.size() == 0) {
                        checkedFragment.viewBinding.emptyView.show("您还没有已办案卷", null);
                    } else {
                        checkedFragment.viewBinding.emptyView.hide();
                        checkedFragment.adapter = new CaseCheckResultAdapter(checkedFragment.context, checkedFragment.dataBeans);
                        checkedFragment.viewBinding.caseRecyclerView.setLayoutManager(new LinearLayoutManager(checkedFragment.context));
                        checkedFragment.viewBinding.caseRecyclerView.addItemDecoration(new DividerItemDecoration(checkedFragment.context, DividerItemDecoration.VERTICAL));
                        checkedFragment.viewBinding.caseRecyclerView.setAdapter(checkedFragment.adapter);
                        checkedFragment.adapter.setOnItemClickListener(new CaseCheckResultAdapter.OnItemClickListener() {
                            @Override
                            public void onClick(int position) {
                                Intent intent = new Intent(checkedFragment.context, CaseCheckedDetailActivity.class);
                                intent.putExtra("id", checkedFragment.dataBeans.get(position).getId());
                                checkedFragment.startActivity(intent);
                            }
                        });
                    }
                }
            }
        }
    }

    @Override
    public void obtainCheckListResult(CaseCheckBean resultBean) {
//        Log.d(TAG, "obtainHandledResult: " + new Gson().toJson(resultBean));
        if (resultBean.isSuccess()) {
            List<CaseCheckBean.DataBean.RowsBean> dataRows = resultBean.getData().getRows();
            if (isRefresh) {
                dataBeans.clear();//下拉刷新必须先清空之前的List，不然会出现数据重复的问题
                dataBeans = dataRows;
                viewBinding.refreshLayout.finishRefresh();
                isRefresh = false;
            } else if (isLoadMore) {
                if (dataRows.size() == 0) {
                    ToastHelper.showToast("到底了，别拉了", ToastHelper.INFO);
                }
                dataBeans.addAll(dataRows);
                viewBinding.refreshLayout.finishLoadMore();
                isLoadMore = false;
            } else {
                dataBeans = dataRows;
            }
            weakReferenceHandler.sendEmptyMessage(202104252);
        }
    }

    @Override
    public void onDestroyView() {
        if (caseCheckedPresenter != null) {
            caseCheckedPresenter.disposeRetrofitRequest();
        }
        super.onDestroyView();
    }
}
